package slimeknights.tconstruct.tools.traits;

import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.event.entity.player.PlayerEvent;

import slimeknights.tconstruct.library.traits.AbstractTrait;

/**
 * Increases mining speed for each harvest level the tool is above the required harvest level.
 * So a high level tool with this breaks low level blocks very fast.
 */
public class TraitUnnatural extends AbstractTrait {

  public TraitUnnatural() {
    super("unnatural", EnumChatFormatting.LIGHT_PURPLE);
  }

  @Override
  public void miningSpeed(ItemStack tool, PlayerEvent.BreakSpeed event) {
    Block block = event.state.func_177230_c();
    int hlvl = tool.func_77973_b().getHarvestLevel(tool, block.getHarvestTool(event.state));
    int dif = hlvl - block.getHarvestLevel(event.state);

    // 1 speed per harvest level above
    if(dif > 0) {
      event.newSpeed += dif;
    }
  }

}
